// NpMsgrBuddy.cpp: implementation of the CNpMsgrBuddy class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#if defined(WIN32)
#include "Util.h"
#endif
#include "NpMsgrBuddy.h"

#include <algorithm>
#include <time.h>
#include "GTCommonAPI.h"

#include "ConvertUTF.h"

/*
inline bool IS_WHITESPACE(char ch)
{
	if (ch == ' ' || ch == '\n' || ch == '\r' || ch == '\t')
		return true;
	return false;
}
inline void STR_RTRIM(string & str)
{
	if (str.empty())
		return;

	char *p = str.end();
	do
	{
		p--;
	}
	while (p >= str.begin() && IS_WHITESPACE(*p));

	p++;

	if (p < str.end())
		str.resize( p - str.begin() );
}
*/


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNpMsgrBuddy::CNpMsgrBuddy()
{
	m_pNpMsgrUser = NULL;
	m_pNpMsgrConfig = NULL;
	m_pNpSD = NULL;

	m_ulLastSaved_BuddyListCacheSerial = 0;
	m_ulBuddyListCacheSerial = 0;
}

CNpMsgrBuddy::~CNpMsgrBuddy()
{
	ClearAll();
}

/*
void CALLBACK CNpMsgrBuddy::OnReceive_BuddyProfile(LPCSTR szFromId, LPCWSTR wszName, LPCWSTR wszMobilePhone, bool & bPermitResponse)
{
	CBuddy * pBuddy = _FindBuddy( szFromId, BTYPE_ALL );
	bPermitResponse = false;
	
	if( pBuddy )
	{
		pBuddy->m_wstrName = wszName;
		pBuddy->m_wstrMobilePhone = wszMobilePhone;
		
		if( pBuddy->IsMyBuddy() && pBuddy->IsBlockBuddy() == false )
		{
			bPermitResponse = true;
		}
	}					
}
*/

///////////////////////////////////////////////////////////////////////////////////
//

CBuddy * CNpMsgrBuddy::_AddBuddy(BYTE byteBType, LPCWSTR wszId, LPCWSTR wszNick, bool *pbCreated)
{
	if(pbCreated) *pbCreated = false;

	CBuddy * pBuddy = _FindBuddy( wszId, BTYPE_ALL );
	if( pBuddy )
	{

		if( (pBuddy->m_byteBuddyType & byteBType) == byteBType )
		{
			return pBuddy;	// ̹ ..
		}
	}
	else
	{
		pBuddy = new CBuddy;
		if (NULL == pBuddy)
			return NULL;

		pBuddy->m_wstrId = wszId;
		pBuddy->m_wstrNick = wszNick;
		m_listBuddy.push_back( pBuddy );

		if(pbCreated) *pbCreated = true;
	}

	pBuddy->m_byteBuddyType |= byteBType;

	if( pBuddy->m_wstrNick.length() == 0 && wcslen(wszNick) > 0 )
		pBuddy->m_wstrNick = wszNick;

	return pBuddy;
}

CBuddy * CNpMsgrBuddy::_RemoveBuddy(BYTE byteBType, LPCWSTR wszId)
{
	CBuddy * pBuddy = NULL;
	
	list<CBuddy*>::iterator it = m_listBuddy.begin();
	for ( ; it != m_listBuddy.end() ; it++)
	{
		if( (*it)->m_wstrId == wszId )
		{
			pBuddy = *it;
			break;
		}
	}
	
	if( !pBuddy )
		return pBuddy;
	
	pBuddy->m_byteBuddyType &= ~byteBType;
	
	if( pBuddy->m_byteBuddyType == 0 )
	{
		m_listBuddy.erase( it );
		
		CGroup * pGroup;
		list<CGroup*>::iterator it_group = m_listGroup.begin();
		for ( ; it_group != m_listGroup.end() ; it_group++)
		{
			pGroup = *it_group;
			list<CBuddy*>::iterator it2 = find( pGroup->m_listChildBuddy.begin(), pGroup->m_listChildBuddy.end(), pBuddy );
			if( it2 != pGroup->m_listChildBuddy.end() )
			{
				pGroup->m_listChildBuddy.erase( it2 );
			}
		}
		
		delete pBuddy;
	}

	return pBuddy;
}

CBuddy * CNpMsgrBuddy::_RemoveBuddy(BYTE byteBType, LPCWSTR wszId, int nGroupId)
{
	CBuddy * pBuddy = NULL;
	
	list<CBuddy*>::iterator it = m_listBuddy.begin();
	for ( ; it != m_listBuddy.end() ; it++)
	{		
		if( (*it)->m_wstrId == wszId )
		{
			pBuddy = *it;
			break;
		}
	}
	
	if( !pBuddy )
		return pBuddy;
	
	pBuddy->m_byteBuddyType &= ~byteBType;
	
	if( pBuddy->m_byteBuddyType == 0 )
	{
		m_listBuddy.erase( it );
		
		CGroup * pGroup;
		list<CGroup*>::iterator it_group = m_listGroup.begin();
		for ( ; it_group != m_listGroup.end() ; it_group++)
		{
			pGroup = *it_group;		
			if(pGroup->Gid() == nGroupId)
			{
				list<CBuddy*>::iterator it2 = find( pGroup->m_listChildBuddy.begin(), pGroup->m_listChildBuddy.end(), pBuddy );
				if( it2 != pGroup->m_listChildBuddy.end() )
				{
					pGroup->m_listChildBuddy.erase( it2 );
				}
			}
		}
		
		delete pBuddy;
	}

	return pBuddy;
}

////////////////////////////////////////////////////////////////////////////
// INpMsgrBuddy

void __stdcall CNpMsgrBuddy::AdviseEvents(_INpMsgrBuddyEvents * pEvents) // support multiple event receiver
{
	m_vecEvents.push_back( pEvents );
}

void __stdcall CNpMsgrBuddy::UnadviseEvents(_INpMsgrBuddyEvents * pEvents)
{
	vector<_INpMsgrBuddyEvents*>::iterator it = find( m_vecEvents.begin(), m_vecEvents.end(), pEvents );
	if( it != m_vecEvents.end() )
		m_vecEvents.erase( it );

}

void __stdcall CNpMsgrBuddy::InitModule(INpMsgrUser * pNpMsgrUser, INpMsgrConfig * pNpMsgrConfig,
		INpSessionDispatcher * pN5S_QM_MainServer)
{
	m_pNpMsgrUser = pNpMsgrUser;
	m_pNpMsgrConfig = pNpMsgrConfig;
	m_pNpSD = pN5S_QM_MainServer;

	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_INITONLINE, this );
	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_NOTIFYONLINE, this );
	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_NOTIFY_MESSAGE, this );
	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_NOTIFYPROFILE, this );
	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_RESPONSEPROBING, this );
	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_NOTIFYADDEDBUDDY, this );
	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_IPTSTATUS, this );
	//{ 2005/06/12 by chan
	m_pNpSD->Register_CToC_PACKET_Handler( CToC_MMCIVNITE, this );
	m_pNpSD->Register_CToC_PACKET_Handler( CToC_MMC_FORCE_KICK, this );
	//}

	m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_IPTCLIENT, this );
}

////////////////////////////////////////////////////////////////////////////
//

bool CNpMsgrBuddy::Load_BuddyListCache()
{
	bool bRes = false;
	size_t dwLength = 0;
	char * pData = NULL;
	char szFilePath[MAX_PATH+1];

	//////////////////////////////////////////////////////////////////
	// load buddy list

	m_pNpMsgrConfig->GetFilePath( "BuddyListCache", szFilePath );
	pData = GTCommonAPI::ReadDataFileAlloc( szFilePath, dwLength );
	if( NULL != pData )
	{
		if( dwLength > 0 )
		{
			CGBStream stream;
			stream.UseExternalBuffer( pData, dwLength );

			ULONG ulBuddyListCacheSerial = stream.Read_U4();

			USHORT usArrayCount = stream.Read_U2();

			bRes = Init_BuddyList( ulBuddyListCacheSerial, usArrayCount, stream );

			if( bRes )
				m_ulLastSaved_BuddyListCacheSerial = ulBuddyListCacheSerial;
		}
		
		delete [] pData;
	}
	return bRes;
}

bool CNpMsgrBuddy::Init_BuddyList(ULONG ulCacheSerial, USHORT usArrayCount, CGBStream & stream)
{
	try
	{
		USHORT usRecordLength;
		int i;

		for( i=0 ; i<usArrayCount ; i++ )
		{
			usRecordLength = stream.Read_U2();
			USHORT usReadLength = 0;
			
			BYTE buddyType = stream.Read_U1();
			usReadLength += 1;
			
			WSTRING wstrBuddyId;
			usReadLength += stream.Read_U8SS_to_Unicode_stl( wstrBuddyId );

			// HJS:   ģ 𸮽Ʈ 
			if( buddyType == BTYPE_NONE )
				continue;

#if defined(WIN32)
			string strBuddyId;
			stl_ik_wcs2mbs( wstrBuddyId.c_str(), strBuddyId );
//			IK_TRACE("\t[%30s] buddy type=%d\n", strBuddyId.c_str(), buddyType );
#endif			
			_AddBuddy( buddyType & /*(BTYPE_FL | BTYPE_WL)*/BTYPE_FL, wstrBuddyId.c_str() );

			if( usRecordLength > usReadLength )
				stream.Skip( usRecordLength - usReadLength );
			else if( usRecordLength < usReadLength )
				throw CGBStreamException(GBS_E_OVERREAD_RECORDEND);
		}
	}
	catch( CGBStreamException e )
	{
		return false;
	}

	m_ulBuddyListCacheSerial = ulCacheSerial;
	USER()->SetCacheSerial_Buddy(m_ulBuddyListCacheSerial);
	return true;
}


bool CNpMsgrBuddy::Save_BuddyListCache(int nNewSerial)
{
	char szFilePath[MAX_PATH+1];
	CGBStream stream;
	stream.CreateStream(65536);
	
	if(nNewSerial > 0)
		m_ulBuddyListCacheSerial = nNewSerial;
	
	stream.Write_U4( m_ulBuddyListCacheSerial );
	USER()->SetCacheSerial_Buddy(m_ulBuddyListCacheSerial);
	//////////////////////////////////////////////////////////////////
	// save buddy list

	// A( R )	 Ʈ ڵ 迭R(type(U1), id(SS))

	try
	{
		USHORT usArrayCount;
		USHORT usRecordLength;
		
		// A( R )	 Ʈ ڵ 迭R(type(U1), id(SS))
		usArrayCount = m_listBuddy.size();
		stream.Write_U2( usArrayCount );

		list<CBuddy*>::iterator it;
		for( it = m_listBuddy.begin() ; it != m_listBuddy.end() ; it++ )
		{
			CBuddy * pBuddy = *it;

			UTF8 *utf8ID = pBuddy->Id_UTF8();
			if (NULL == utf8ID)
			{
				return FALSE;
			}

			usRecordLength = 1 + (1+strlen((LPCSTR)utf8ID));
			stream.Write_U2( usRecordLength );
			stream.Write_U1( pBuddy->m_byteBuddyType );
			stream.Write_U8SS( utf8ID );
		}
	}
	catch( CGBStreamException e )
	{
		return false;
	}
	
	m_pNpMsgrConfig->GetFilePath( "BuddyListCache", szFilePath );
	if( GTCommonAPI::WriteDataFile( szFilePath, stream.GetData(), stream.GetDataLen() ) )
		m_ulLastSaved_BuddyListCacheSerial = m_ulBuddyListCacheSerial;

	return true;
}

bool CNpMsgrBuddy::Load_BuddyProfileCache()
{
	bool bRes = false;
	size_t dwLength = 0;
	char * pData = NULL;
	char szFilePath[MAX_PATH+1];
	
	//////////////////////////////////////////////////////////////////
	// load buddy profile
	
	m_pNpMsgrConfig->GetFilePath( "BuddyProfileCache", szFilePath );
	pData = GTCommonAPI::ReadDataFileAlloc( szFilePath, dwLength );
	if( NULL != pData )
	{	
		if( dwLength > 0 )
		{
			CGBStream stream;
			stream.UseExternalBuffer( pData, dwLength );

			bRes = Init_BuddyProfile( stream );
		}
		
		delete [] pData;
	}
	return bRes;
}

bool CNpMsgrBuddy::Init_BuddyProfile(CGBStream & stream)
{
	try
	{
		USHORT usArrayCount;
		
		// A( R )	 Ʈ ڵ 迭 R{id(SS), name(U8S), nick(U8S), phone(U8S) ... }
		usArrayCount = stream.Read_U2();

		for( int i=0 ; i < usArrayCount ; i++ )
		{
			USHORT usRecordLength = stream.Read_U2();
			USHORT usReadLength = 0;

			WSTRING wstrId;
			usReadLength += stream.Read_U8SS_to_Unicode_stl( wstrId );

			CBuddy * pBuddy = _FindBuddy( wstrId.c_str(), BTYPE_ALL );
			if( pBuddy )
			{
				usReadLength += stream.Read_U8S_to_Unicode_stl( pBuddy->m_wstrNick );

				WSTRING wstrProfileDataName;
				WSTRING wstrProfileDataValue;
				
				while( usReadLength < usRecordLength )
				{
					usReadLength += stream.Read_U8S_to_Unicode_stl( wstrProfileDataName );
					usReadLength += stream.Read_U8S_to_Unicode_stl( wstrProfileDataValue );
					
					pBuddy->SetProfile( wstrProfileDataName.c_str(), wstrProfileDataValue.c_str() );
				}
			}
			
			if( usRecordLength > usReadLength )
				stream.Skip( usRecordLength - usReadLength );
			else if( usRecordLength < usReadLength )
				throw CGBStreamException(GBS_E_OVERREAD_RECORDEND);
		}
	}
	catch( CGBStreamException e )
	{
		return false;
	}
	
	return true;
}

bool CNpMsgrBuddy::Save_BuddyProfileCache()
{
	CGBStream stream;
	stream.CreateStream();
	
	try
	{
		USHORT usArrayCount;
		
		// A( R )	 Ʈ ڵ 迭 R{id(SS), name(U8S), nick(U8S), phone(U8S) ... }
		usArrayCount = m_listBuddy.size();
		stream.Write_U2( usArrayCount );

		int nProfileDataSize = 0;
		list<CBuddy*>::iterator it;
		for( it = m_listBuddy.begin() ; it != m_listBuddy.end() ; it++ )
		{
			CBuddy * pBuddy = *it;

			CGBStream stream_r;
			stream_r.CreateStream();

			UTF8 *utf8ID = pBuddy->Id_UTF8();
			if (NULL == utf8ID)
				return false;

			stream_r.Write_U8SS( utf8ID );
			stream_r.Write_U8S_from_Unicode( pBuddy->m_wstrNick );
			
			nProfileDataSize = static_cast<int>(pBuddy->m_vecProfileData.size());
			for( int i=0 ; i <  nProfileDataSize; i++ )
			{
				stream_r.Write_U8S_from_Unicode( pBuddy->m_vecProfileData[i].m_wstrProfileName );
				stream_r.Write_U8S_from_Unicode( pBuddy->m_vecProfileData[i].m_wstrValue );
			}

			stream.Write_S( stream_r.GetData(), static_cast<USHORT>(stream_r.GetDataLen()) );		// record write
		}
	}
	catch( CGBStreamException e )
	{
		return false;
	}
	
	char szFilePath[MAX_PATH+1];
	m_pNpMsgrConfig->GetFilePath( "BuddyProfileCache", szFilePath );
	GTCommonAPI::WriteDataFile( szFilePath, stream.GetData(), stream.GetDataLen() );

	return true;
}


void CNpMsgrBuddy::Save_All_BuddyCacheData()
{
//	if( strlen( USER()->Id_MBCS() ) == 0 )
//		return;
//
	if( m_ulLastSaved_BuddyListCacheSerial != m_ulBuddyListCacheSerial )
	{
		Save_BuddyListCache();
	}

	Save_BuddyProfileCache();
}

void __stdcall CNpMsgrBuddy::ClearAll()
{
	m_ulLastSaved_BuddyListCacheSerial = 0;
	m_ulBuddyListCacheSerial = 0;
	
	if( !m_listGroup.empty() )
	{
		list<CGroup*>::iterator it = m_listGroup.begin();
		for( ; it != m_listGroup.end() ; it++ )
		{
			CGroup* pGroup = *it;
			delete pGroup;
		}
		
		m_listGroup.clear();
	}
	
	if( !m_listBuddy.empty() )
	{		
		list<CBuddy*>::iterator it = m_listBuddy.begin();
		for( ; it != m_listBuddy.end() ; it++ )
		{
			CBuddy* pBuddy = *it;
			delete pBuddy;
		}
		
		m_listBuddy.clear();
	}

	if( !m_listBuddyQuery.empty() )
	{
		list<CBuddyQueryItem*>::iterator it = m_listBuddyQuery.begin();
		for( ; it != m_listBuddyQuery.end() ; it++ )
		{
			CBuddyQueryItem* p = *it;
			delete p;
		}
		m_listBuddyQuery.clear();
	}
}

int CNpMsgrBuddy::SendQuery( USHORT usCMD, USHORT usBodyDataLen, LPCSTR szBodyData, int nCallerTrId )
{
	int nTrId = m_pNpSD->Send_REQUEST_PACKET( usCMD, usBodyDataLen, szBodyData, this );

	CBuddyQueryItem * query = new CBuddyQueryItem( nTrId, usCMD, szBodyData, usBodyDataLen, nCallerTrId );

	if (NULL != query) m_listBuddyQuery.push_back( query );

	return nTrId;
}



bool __stdcall CNpMsgrBuddy::Sync_AddBuddyByEncryptedId( LPCWSTR wszId, LPCWSTR wszMsg )
{
	return true;
}

size_t CNpMsgrBuddy::_GetUserIDsStreamLen( const vector<wstring> &vecUserID )
{
	const size_t nSizeOfLenPacket = 1;
	const size_t nSizeOfGroupIdPacket = 4;
	const size_t nSizeOfUserCntPacket = 1;

	size_t nUserIDsLen = 0;
	nUserIDsLen += nSizeOfGroupIdPacket;
	nUserIDsLen += nSizeOfUserCntPacket;

	for(vector<wstring>::const_iterator itr = vecUserID.begin(); itr != vecUserID.end(); itr++)
		nUserIDsLen += strlen( (_t_UTF8)((LPCWSTR)itr->c_str()) ) + nSizeOfLenPacket;

	return nUserIDsLen;
}

size_t CNpMsgrBuddy::_GetUserIDsStreamLen( const vector< pair<wstring, int> > &vecUserID )
{
	const size_t nSizeOfLenPacket = 1;
	const size_t nSizeOfGroupIdPacket = 4;
	const size_t nSizeOfUserCntPacket = 1;

	size_t nUserIDsLen = 0;
	nUserIDsLen += nSizeOfGroupIdPacket;
	nUserIDsLen += nSizeOfUserCntPacket;

	for(vector< pair<wstring, int> >::const_iterator itr = vecUserID.begin(); itr != vecUserID.end(); itr++)
	{
		nUserIDsLen += strlen( (_t_UTF8)((LPCWSTR)itr->first.c_str()) ) + nSizeOfLenPacket;
		nUserIDsLen += nSizeOfGroupIdPacket;
	}

	return nUserIDsLen;
}

bool __stdcall CNpMsgrBuddy::Sync_AddBuddy(int nGroupID, std::vector<wstring> &vecUserID, LPCWSTR wszMsg, int nTrid)
{
	CGBStream stream;	
	stream.CreateStream(_GetUserIDsStreamLen(vecUserID));
	
	stream.Write_U4( nGroupID );
	stream.Write_U1(vecUserID.size());
	for(std::vector<wstring>::iterator itr = vecUserID.begin(); itr != vecUserID.end(); itr++)
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)itr->c_str()));

	SendQuery( static_cast<USHORT>(MSNG_CMD_ADDBUDDY), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );

	return true;
}

bool __stdcall CNpMsgrBuddy::Sync_RemoveBuddy( vector< pair<wstring, int> > &vecUserID, bool bDelGroup, int nTrid )
{
	const size_t nSizeOfDelGroupFlagPacket = 1;

	CGBStream stream;	
	stream.CreateStream(_GetUserIDsStreamLen(vecUserID) + nSizeOfDelGroupFlagPacket);

	stream.Write_U1( bDelGroup ? 1 : 0 );
	stream.Write_U1(vecUserID.size());
	for(vector< pair<wstring, int> >::iterator itr = vecUserID.begin(); itr != vecUserID.end(); itr++)
	{
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)itr->first.c_str()));
		stream.Write_U4( itr->second );
	}
	
	SendQuery( static_cast<USHORT>(MSNG_CMD_DELBUDDY), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );

	return true;
}

bool __stdcall CNpMsgrBuddy::Sync_RejectBuddy( LPCWSTR wszId )
{
	return true;
}

bool __stdcall CNpMsgrBuddy::Sync_RemoveWaitBuddy(LPCWSTR wszId, int nTrid)
{
	return true;
}

bool __stdcall CNpMsgrBuddy::Sync_AddBlockBuddy( LPCWSTR wszId, int nTrid )
{
	return true;
}

bool __stdcall CNpMsgrBuddy::Sync_RemoveBlockBuddy( LPCWSTR wszId, int nTrid )
{
	return true;
}

IBuddyEnum * __stdcall CNpMsgrBuddy::GetAllBuddys(BYTE byteBType)
{
	CBuddyEnum * pBuddyEnum = new CBuddyEnum;
	if (NULL == pBuddyEnum)
		return NULL;

	CBuddy *pBuddy;

	list<CBuddy*>::iterator it = m_listBuddy.begin();
	for ( ; it != m_listBuddy.end() ; it++)
	{
		pBuddy = *it;

		if( pBuddy->m_byteBuddyType & byteBType )
			pBuddyEnum->m_vecBuddy.push_back( pBuddy );
	}

	return pBuddyEnum;
}


IBuddy * __stdcall CNpMsgrBuddy::FindBuddy(LPCWSTR wszId, BYTE byteBType)
{
	return _FindBuddy( wszId, byteBType );
}


//////////////////////////////////////////////////////////////////////////////
//


IBuddyEnum * __stdcall CGroup::GetChildBuddys()
{
	CBuddyEnum * pBuddyEnum = new CBuddyEnum;
	if (NULL == pBuddyEnum)
		return NULL;

	CBuddy *pBuddy;

	list<CBuddy*>::iterator it = m_listChildBuddy.begin();
	for ( ; it != m_listChildBuddy.end() ; it++)
	{
		pBuddy = *it;
		pBuddyEnum->m_vecBuddy.push_back( pBuddy );
	}

	return pBuddyEnum;
}

bool __stdcall CGroup::IsChildBuddyNode( IBuddy * pBuddy )
{
	list<CBuddy*>::iterator it;
	it = find( m_listChildBuddy.begin(), m_listChildBuddy.end(), pBuddy );

	if( it != m_listChildBuddy.end() )
		return true;

	return false;
}

//class _INpSessionDispatcher_PacketHandler
void CALLBACK CNpMsgrBuddy::INpSessionDispatcher_OnReceive_REQUEST_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pPacket)
{
#if defined(WIN32)	
//	F_TRACE("CNpMsgrBuddy::INpSessionDispatcher_OnReceive_REQUEST_PACKET, cmd = 0x%04x\n", pPacket->M6V2()->usCMMD);
#endif	
	
		
	CGBStream stream;
	stream.UseExternalBuffer( pPacket->BodyData(), pPacket->BodyLength() );
	
	USHORT usCMMD = pPacket->M6V2()->usCMMD;
	switch( usCMMD )
	{
	case MSNG_CMD_INITONLINE:		// 0x0401
	case MSNG_CMD_NOTIFYONLINE:		// 0x0404
	case MSNG_CMD_RESPONSEPROBING:	// 0x0407
		
		//IK_TRACE("cmd = 0x%04x\n", pPacket->M6V2()->usCMMD );
		/*
		TYPE	DESCRIPTION
		U1	 ÷   0x01:   0x02:  
		U1	¶ 
		U8S	
		*/
		{
			int status_changed_flag = 0;

			WSTRING wstrBuddyId;
			BYTE flag;
			BYTE status;
			WSTRING wstrNick;
			uint16_t ostype = 0;
			
			string customData;

			int nEventsSize;

			try
			{
				stream.Read_U8SS_to_Unicode_stl( wstrBuddyId );

				OutputDebugString(_T("~~~~~~~~~ MSNG_CMD_NOTIFYONLINE ~~~~~~~~~\r\n"));
				OutputDebugString((LPCSTR)(_t_UTF8)wstrBuddyId.c_str());
				OutputDebugString(_T("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\r\n"));

				flag = stream.Read_U1();

				status = stream.Read_U1();
				
				if( flag & NOTIFY_FLAG_NICK )
					stream.Read_U8S_to_Unicode_stl(wstrNick);
			}
			catch( CGBStreamException e )
			{
//				DLOG("[IN] CNpMsgrBuddy::INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\t"
//					"PACKET body parse fail!!, e.Error()=%d, cmmd=0x%04x", 
//					e.Error(), pPacket->M6V2()->usCMMD );
				return;
			}

//			IK_TRACE("NOTIFY [cmd = 0x%04x] [%s] flag=%d status=%d, nick=%s\n", pPacket->M6V2()->usCMMD, 
//				(LPCSTR)(_t_UTF8)wstrBuddyId.c_str(), flag, status,
//				(LPCSTR)(_t_UTF8)wstrNick.c_str());

//			NTALK_LOG->Debug(L"[BUDDY] MSNG_CMD_NOTIFYONLINE ID:[%s] FLAG:[%d] STATUS:[%d] NICK:[%s]", wstrBuddyId.c_str(), flag, status, wstrNick.c_str());



			// Ͽ г   PC гӵ Ѵ.
			if( wstrBuddyId.compare( USER()->Id() ) == 0 )
			{
				for( int i=0 ; i <  static_cast<int>(m_vecEvents.size()); i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnMyStatusChanged(flag, wstrNick, status, 0);	// IPT  ȿ  flag Ǿ  ʴ.
			}
			else
			{
				// , ȭâ  ã ̿ 
				nEventsSize = static_cast<int>(m_vecEvents.size());
				for( int i=0 ; i <  nEventsSize; i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnNotBuddyStatusChanged( wstrBuddyId.c_str(), status, wstrNick.c_str(), 0, flag );	// IPT  ȿ  flag Ǿ  ʴ.

				// ã 
				CBuddy * pBuddy = _FindBuddy( wstrBuddyId.c_str(), BTYPE_FL );
				if( !pBuddy )
					return;

				if( flag & NOTIFY_FLAG_PRESENCE )	//1 = STATUS, 2 = NICK, 4 = CUSTOM DATA
				{
					bool bPrevOffline = pBuddy->IsOffline();

					if( pBuddy->m_OnlineStatus != status )
					{
						status_changed_flag |= eBA_STATUS;
						pBuddy->m_OnlineStatus = (E_MSGR_ONLINE_STATUS)status;
					}

					if( bPrevOffline && !pBuddy->IsOffline() )
					{
						status_changed_flag |= eBA_LOGIN;

						// offline  online  ȳ༮
						// ̰ α Ƽ̿     ƴϴ. 
						// MSNG_CMD_RESPONSEPROBING   α ؼ ģ  
						// PROBING     ̱  ģ α  ƴϴ.
						// UI layer  ̰ ˾Ƽ óؾ  ÷׷ ǥѴ.

						if( MSNG_CMD_RESPONSEPROBING == pPacket->M6V2()->usCMMD )
							status_changed_flag |= eBA_INITIAL_PROBE_RES;
					}
				}

				if( flag & NOTIFY_FLAG_NICK )
				{
					if( pBuddy->m_wstrNick != wstrNick )
					{
						status_changed_flag |= eBA_NICK;
						pBuddy->m_wstrNick = wstrNick;
					}
				}

				//if( flag & NOTIFY_FLAG_IPT )
				//{
				//	status_changed_flag |= eBA_IPT;
				//	pBuddy->m_IPTStatus = (E_MSGR_IPT_STATUS)iptStatus;
				//}

				nEventsSize = static_cast<int>(m_vecEvents.size());
				for( int i=0 ; i <  nEventsSize; i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnBuddyStatusChanged( pBuddy, status_changed_flag, customData.c_str(), customData.size() );
			}
		}
		break;
	case MSNG_CMD_IPTSTATUS:
		{
			OutputDebugString(_T("~~~~~~~~~ RESPONSE OF REQUEST_PACKET: MSNG_CMD_IPTSTATUS ~~~~~~~~~\r\n"));

			BYTE flag = NOTIFY_FLAG_IPT;
			int status_changed_flag = eBA_NONE;

			WSTRING wstrBuddyId;
			BYTE iptStatus = STIPT_UNKNOWN;

			try
			{
				stream.Read_U8SS_to_Unicode_stl( wstrBuddyId );
				iptStatus = stream.Read_U1();

				if( iptStatus < STIPT_IDLE || iptStatus > STIPT_DND)
					iptStatus = STIPT_UNKNOWN;

				//char strDebug[1024];
				//wsprintf(strDebug, "IPTSTATUS : [%s] [%d]", wstrBuddyId.c_str(), iptStatus);
				//OutputDebugString(strDebug);
			}
			catch( CGBStreamException e )
			{
//				DLOG("[IN] CNpMsgrBuddy::INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\t"
//					"PACKET body parse fail!!, e.Error()=%d, cmmd=0x%04x", 
//					e.Error(), pPacket->M6V2()->usCMMD );
				return;
			}

			//  ȭ  
			if( wstrBuddyId.compare( USER()->Id() ) == 0 )
			{
				wstring strNickName;
				for( int i=0 ; i <  static_cast<int>(m_vecEvents.size()); i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnMyStatusChanged(flag, strNickName, 0, iptStatus);	// ޽   ȭ ȿ  flag Ǿ  ʴ.

//				NTALK_LOG->Debug(L"[IPT] MY IPTSTATUS : [%s] [%d]", wstrBuddyId.c_str(), iptStatus);
			}
			else
			{
//				GT_FLOG(L"IPTSTATUS : [%s] [%d]", wstrBuddyId.c_str(), iptStatus);

				// , ȭâ,   ã ̿ 
				int nEventsSize = static_cast<int>(m_vecEvents.size());
				for( int i=0 ; i <  nEventsSize; i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnNotBuddyStatusChanged( wstrBuddyId.c_str(), 0,(LPCWSTR)_T(""), iptStatus, flag );	// ޽   ȭ ȿ  flag Ǿ  ʴ.

				// ã IPT 
				CBuddy * pBuddy = _FindBuddy( wstrBuddyId.c_str(), BTYPE_FL );
				if( !pBuddy )
					return;

				status_changed_flag |= eBA_IPT;
				pBuddy->m_IPTStatus = (E_MSGR_IPT_STATUS)iptStatus;

				nEventsSize = static_cast<int>(m_vecEvents.size());
				for( int i=0 ; i <  nEventsSize; i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnBuddyStatusChanged( pBuddy, status_changed_flag, NULL, 0 );
			}
		}
		break;
	case MSNG_CMD_IPTCLIENT:
		{
			OutputDebugString(_T("~~~~~~~~~ RESPONSE OF REQUEST_PACKET: MSNG_CMD_IPTCLIENT ~~~~~~~~~\r\n"));

			uint16_t usIPTCMMD = stream.Read_U2();
			switch( usIPTCMMD )
			{
			case IPT_CMD_NOTIFYCALLINFO:	// ȭ   ˸
				{
					OutputDebugString(_T("~~~~~~~~~ RESPONSE OF REQUEST_PACKET: IPT_CMD_NOTIFYCALLINFO ~~~~~~~~~\r\n"));
					std::wstring strUserID;
					std::wstring strTelNo;
					std::wstring strCID;

					try
					{
						stream.Read_U8SS_to_Unicode_stl(strUserID);	// ߽ID

						stream.Read_U8SS_to_Unicode_stl(strTelNo);	// ߽ ȭȣ

						stream.Read_U8SS_to_Unicode_stl(strCID);	// Call ID: Session Unique 
					}
					catch( CGBStreamException e )
					{
//						DLOG("[IN] INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\tPACKET body parse fail!!, e.Error()=%d, ipt cmmd=0x%04x", e.Error(), usIPTCMMD );
						return;
					}

//					GT_FLOG(L"IPT_CMD_NOTIFYCALLINFO : [%s][%s][%s]", strUserID.c_str(), strTelNo.c_str(), strCID.c_str());

					int nEventsSize = static_cast<int>(m_vecEvents.size());
					for( int i=0 ; i <  nEventsSize; i++ )
						m_vecEvents[i]->NpMsgrIPT_OnNotifyCallInfo(strUserID.c_str(), strTelNo.c_str(), strCID.c_str());
				}
				break;
			case RESPONSE(IPT_CMD_PHONECALL):	// ȭ ɱ û 
				{
					OutputDebugString(_T("~~~~~~~~~ RESPONSE OF REQUEST_PACKET: RESPONSE(IPT_CMD_PHONECALL) ~~~~~~~~~\r\n"));

					BYTE res;
					std::wstring strCID;

					try
					{
						res = stream.Read_U1();						// û  (0:  1: )
						stream.Read_U8SS_to_Unicode_stl(strCID);	// Call ID: Session Unique 
					}
					catch( CGBStreamException e )
					{
//						DLOG("[IN] INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\tPACKET body parse fail!!, e.Error()=%d, ipt cmmd=0x%04x", e.Error(), usIPTCMMD );
						return;
					}

//					GT_FLOG(L"IPT_CMD_PHONECALL : [%d][%s]", res, strCID.c_str());

					int nEventsSize = static_cast<int>(m_vecEvents.size());
					for( int i=0 ; i <  nEventsSize; i++ )
						m_vecEvents[i]->NpMsgrIPT_OnResponsePhoneCall(res, strCID.c_str());
				}
				break;
			case RESPONSE(IPT_CMD_HANGUP):
			case RESPONSE(IPT_CMD_SETCALLFORWARDING):
			case RESPONSE(IPT_CMD_SETHOTRANSFER):
			case RESPONSE(IPT_CMD_PICKUP):
			case RESPONSE(IPT_CMD_SETDND):
			case RESPONSE(IPT_CMD_GETPHONESTATUS):
			case RESPONSE(IPT_CMD_ANSWERCALL):
			case RESPONSE(IPT_CMD_CONFERENCECALL):
			case RESPONSE(IPT_CMD_HOLDCALL):
			case RESPONSE(IPT_CMD_RESUMECALL):
				{
					BYTE ret;

					try
					{
						ret = stream.Read_U1();	// û 	0: , 1: 
					}
					catch( CGBStreamException e )
					{
//						DLOG("[IN] INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\tPACKET body parse fail!!, e.Error()=%d, ipt cmmd=0x%04x", e.Error(), usIPTCMMD );
						return;
					}

//					GT_FLOG(L"IPT_CMD_COMMAND : [%x][%d]", usIPTCMMD, ret);

					int nEventsSize = static_cast<int>(m_vecEvents.size());
					for( int i=0 ; i <  nEventsSize; i++ )
						m_vecEvents[i]->NpMsgrIPT_OnResponseResult(ret, usIPTCMMD);
				}
				break;
			case RESPONSE(IPT_CMD_GETCALLFORWARDINGINFO):
				{
					OutputDebugString(_T("~~~~~~~~~ RESPONSE OF REQUEST_PACKET: RESPONSE(IPT_CMD_GETCALLFORWARDINGINFO) ~~~~~~~~~\r\n"));

					BYTE ret;
					BYTE act;
					std::wstring strUserID, strTelNo;

					try
					{
						ret = stream.Read_U1();	// û  (0: , 1: )

						stream.Read_U8SS_to_Unicode_stl(strUserID);	//  ID

						act = stream.Read_U1();	//  	0:  , 1: 

						stream.Read_U8SS_to_Unicode_stl(strTelNo);	// ȭȣ
					}
					catch( CGBStreamException e )
					{
//						DLOG("[IN] INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\tPACKET body parse fail!!, e.Error()=%d, ipt cmmd=0x%04x", e.Error(), usIPTCMMD );
						return;
					}

//					GT_FLOG(L"IPT_CMD_GETCALLFORWARDINGINFO : [%d][%s][%d][%s]", ret, strUserID.c_str(), act, strTelNo.c_str());

					int nEventsSize = static_cast<int>(m_vecEvents.size());
					for( int i=0 ; i <  nEventsSize; i++ )
						m_vecEvents[i]->NpMsgrIPT_OnResponseForwardingInfo(ret, act, strTelNo.c_str());
				}
				break;
			case RESPONSE(IPT_CMD_DNDSTATUSINFO):
				{
					OutputDebugString(_T("~~~~~~~~~ RESPONSE OF REQUEST_PACKET: RESPONSE(IPT_CMD_DNDSTATUSINFO) ~~~~~~~~~\r\n"));

					BYTE ret;
					BYTE act;

					try
					{
						ret = stream.Read_U1();	// û  (0: , 1: )

						act = stream.Read_U1();	//  	0:  , 1: 
					}
					catch( CGBStreamException e )
					{
//						DLOG("[IN] INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\tPACKET body parse fail!!, e.Error()=%d, ipt cmmd=0x%04x", e.Error(), usIPTCMMD );
						return;
					}

//					GT_FLOG(L"IPT_CMD_GETCALLFORWARDINGINFO : [%d][%d]", ret, act);

					int nEventsSize = static_cast<int>(m_vecEvents.size());
					for( int i=0 ; i <  nEventsSize; i++ )
						m_vecEvents[i]->NpMsgrIPT_OnResponseDndInfo(ret, act);
				}
				break;
			}
		}
		break;
	case MSNG_CMD_NOTIFY_MESSAGE:
		{
			unsigned int nMessageCode = 0;
			int nMsgSize;
			const char * pMsg = NULL;
			WSTRING wstrBuddyId;
			try
			{
				stream.Read_U8SS_to_Unicode_stl( wstrBuddyId );
				nMessageCode = stream.Read_U4();
				nMsgSize = stream.Read_U2();
				pMsg = stream.GetData() + stream.GetNextReadPos();
			}
			catch( CGBStreamException e )
			{
//				DLOG("[IN] CNpMsgrBuddy::INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\t"
//					"PACKET body parse fail!!, e.Error()=%d, cmmd=0x%04x", 
//					e.Error(), pPacket->M6V2()->usCMMD );
				return;
			}

			int nEventsSize = static_cast<int>(m_vecEvents.size());
			for( int i=0 ; i <  nEventsSize; i++ )
				m_vecEvents[i]->NpMsgrBuddy_OnNotifyMessage( wstrBuddyId.c_str(), nMessageCode, pMsg, nMsgSize);
		}
		break;
	case MSNG_CMD_NOTIFYPROFILE:
		break;
	case MSNG_CMD_NOTIFYADDEDBUDDY:
		{
			ULONG ulBuddyListCacheSerial;
			WSTRING wstrId, wstrMsg;

			ulBuddyListCacheSerial = stream.Read_U4();
			stream.Read_U8SS_to_Unicode_stl( wstrId );
			stream.Read_U8S_to_Unicode_stl(wstrMsg);
			
			if( wstrId.empty() )
				return;

			m_ulBuddyListCacheSerial = ulBuddyListCacheSerial;
			USER()->SetCacheSerial_Buddy(m_ulBuddyListCacheSerial);
			
			CBuddy * pBuddy = _FindBuddy( wstrId.c_str(), BTYPE_ALL );
			if( pBuddy )
			{
				pBuddy->m_byteBuddyType |= BTYPE_WL;
			}
			else
			{
				ASSERT(FALSE);
			}
			
			int nEventsSize = static_cast<int>(m_vecEvents.size());
			for( int i=0 ; i < nEventsSize ; i++ )
			{
				m_vecEvents[i]->NpMsgrBuddy_OnNotifyAddedBuddy( wstrId.c_str(), wstrMsg.c_str());
			}
		}
		break;
	}
}

void CALLBACK CNpMsgrBuddy::INpSessionDispatcher_OnReceive_RESPONSE_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pOriginalRequestPacket, const INpPacket * pPacket)
{
	m_pNpSD->Deregister_RESPONSE_PACKET_Handler( pPacket->M6V2()->ulTrId );
            
	CBuddyQueryItem* pQueryItem = NULL;
	list<CBuddyQueryItem*>::iterator it = m_listBuddyQuery.begin();
	for( ; it != m_listBuddyQuery.end() ; it++ )
	{
		if( (*it)->m_nTrId == pPacket->M6V2()->ulTrId )
		{
			pQueryItem = *it;
			m_listBuddyQuery.erase( it );
			break;
		}
	}

	if( !pQueryItem )
		return;

	USHORT usQueryResultCode = RC_UNDEFINED;
	string strServerMsg;
	
	CGBStream stream;
	stream.UseExternalBuffer( pPacket->BodyData(), pPacket->BodyLength() );

	USHORT usResponseCode = stream.Read_U2();
	int nCallerTrId = pQueryItem->m_nCallerTrId;

	CGBStream stream_send;
	stream_send.UseExternalBuffer( pQueryItem->m_pszSendData, pQueryItem->m_nSendDataLength );
	
	switch( pQueryItem->m_usCMMD )
	{		
	case MSNG_CMD_ADDBUDDY:
		{
			vector<wstring> vecAddedBuddy;

			CGroup * pParentGroup = NULL;
			CBuddy * pBuddy = NULL;

			int nAddrID = -1;
			int nParentGid = -1;

			WSTRING wszErrMsg;
			wszErrMsg.clear();

			try
			{
				int groupid = stream_send.Read_U4();	//    
				
				int nBuddyCount = stream_send.Read_U1();
				for( int i = 0; i < nBuddyCount; i++ )
				{
					wstring strBuddy;
					stream_send.Read_U8SS_to_Unicode_stl(strBuddy);
					
					vecAddedBuddy.push_back(strBuddy);
				}

				if (usResponseCode == MSNG_OK || usResponseCode == MSNG_OK_ALREADYBUDDY)
				{
					for( vector<wstring>::iterator itr = vecAddedBuddy.begin(); itr != vecAddedBuddy.end(); itr++ )
					{
						bool bCreated = false;
						pBuddy = _AddBuddy( BTYPE_FL, itr->c_str(), STR_EMPTY_WSTRING, &bCreated);	// HJS:  ģ Ƿ   ģ ִ.
					}
					
					m_ulBuddyListCacheSerial = 0;
					int nGroupListCacheSerial = 0;
					nParentGid = stream.Read_U4();
					
					int nInviteBuddyListCacheSerial = 0;
					int ulBuddyAddressBookCacheSerial = 0;
	
					usQueryResultCode = RC_OK;
				}				
				else 
				{
					stream.Read_U8S_to_Unicode_stl(wszErrMsg);
					usQueryResultCode = RC_RECV_ERROR_RESPONSE;
				}
			}
			catch( CGBStreamException e )
			{
				usQueryResultCode = RC_GBSTREAM_PARSE_ERROR;
			}

			int nEventsSize = static_cast<int>(m_vecEvents.size());
			for( int i=0 ; i<nEventsSize ; i++ )
			{
				std::map<LPCWSTR, IBuddy *> mapAddedBuddy;
				for( vector<wstring>::iterator itr = vecAddedBuddy.begin(); itr != vecAddedBuddy.end(); itr++)
				{
					pBuddy = _FindBuddy(itr->c_str(), BTYPE_FL);

					if (NULL != pBuddy)
					{
						std::pair<std::map<LPCWSTR, IBuddy *>::iterator, bool> ret = mapAddedBuddy.insert(std::map<LPCWSTR, IBuddy *>::value_type(pBuddy->Id(), pBuddy));
						if(ret.second == false)
							ASSERT(false);;	// insert ж    ׷쿡 ִ  ϳ  ߰ȴ.
					}
				}

				m_vecEvents[i]->NpMsgrBuddy_OnSync_BuddyAdd(MAKELRESULT(usQueryResultCode, usResponseCode),
															wszErrMsg.c_str(), 
															mapAddedBuddy, 
															pParentGroup,
															nParentGid,
															nAddrID,
															nCallerTrId);
			}

		}
		break;

	case MSNG_CMD_DELBUDDY:
		{
			vector< pair<wstring, int> > vecDeletedBuddy;

			CBuddy * pBuddy = NULL;
			
			WSTRING wstrBuddyId;
			bool bDelGroup;

			try
			{
				// ã   ׷  û ÷
				bDelGroup = stream_send.Read_U1() == 1 ? true : false;

				int nBuddyCount = stream_send.Read_U1();
				for( int i = 0; i < nBuddyCount; i++ )
				{
					pair<wstring, int> buddy;
					stream_send.Read_U8SS_to_Unicode_stl(buddy.first);
					buddy.second = stream_send.Read_U4();
					vecDeletedBuddy.push_back(buddy);
				}
				
				if( usResponseCode == MSNG_OK )
				{
					m_ulBuddyListCacheSerial = 0;//stream.Read_U4();
					int nGroupListCacheSerial = 0;//stream.Read_U4();
                    int nInviteBuddyListCacheSerial = 0;//stream.Read_U4();
                    int nBuddyAddressBookCacheSerial = 0;//stream.Read_U4();
                    
					USER()->SetCacheSerial_Buddy(m_ulBuddyListCacheSerial);
					USER()->SetCacheSerial_Group(nGroupListCacheSerial);
                    USER()->SetCacheSerial_Invite(nInviteBuddyListCacheSerial);
                    USER()->SetCacheSerial_BuddyAddressBook(nBuddyAddressBookCacheSerial);

					usQueryResultCode = RC_OK;
				}
				else
					usQueryResultCode = RC_RECV_ERROR_RESPONSE;
			}
			catch( CGBStreamException e )
			{
				usQueryResultCode = RC_GBSTREAM_PARSE_ERROR;
			}
		
			for( vector< pair<wstring, int> >::const_iterator itr = vecDeletedBuddy.begin(); itr != vecDeletedBuddy.end(); itr++)
			{
				pBuddy = _FindBuddy(itr->first.c_str(), BTYPE_FL);

				bool bLastBuddy = ++itr == vecDeletedBuddy.end();
				itr--;
			
				int nEventsSize = static_cast<int>(m_vecEvents.size());
				for( int i=0 ; i<nEventsSize ; i++ )
					m_vecEvents[i]->NpMsgrBuddy_OnSync_BuddyRemove( MAKELRESULT(usQueryResultCode, usResponseCode), bLastBuddy,	itr->first.c_str(), itr->second, bDelGroup, pBuddy, nCallerTrId);
			}
		}
		break;
	case MSNG_CMD_GETSTATUS:
		{
			
			break;
		}
	}
	
	delete pQueryItem;
}

void CALLBACK CNpMsgrBuddy::INpSessionDispatcher_OnReceive_CToC(INpSessionDispatcher * pEventSource, USHORT usCToC_SubCMMD, const INpPacket * pPacket)
{

	//{ 2005/06/12 by chan

	switch( usCToC_SubCMMD )
	{
	case CToC_MMCIVNITE:
		/*
			U2	Protocol Version
			SS	Phone Tag
		*/
		try
		{
			CGBStream stream;
			WSTRING wstrFromId;
			WSTRING wstrPassword;
			WSTRING wstrRoomTitle;
			WSTRING wstrReqTalkName;

			stream.UseExternalBuffer(pPacket->BodyData(), pPacket->BodyLength());
			string szPhoneTag;
			stream.Read_U2();
			stream.Read_U2();
			stream.Read_U8SS_to_Unicode_stl(wstrFromId);
			stream.Read_SS_stl(szPhoneTag);
			try
			{
				stream.Read_U8SS_to_Unicode_stl(wstrPassword);
				stream.Read_U8SS_to_Unicode_stl(wstrRoomTitle);
				stream.Read_U8SS_to_Unicode_stl(wstrReqTalkName);

			} catch(CGBStreamException e)
			{
			}

			CBuddy * pBuddy = _FindBuddy( wstrFromId.c_str() , BTYPE_BL );

			int nEventsSize = static_cast<int>(m_vecEvents.size());
			for( int i=0 ; i <  nEventsSize; i++ )
			{
				if ( !pBuddy )
					m_vecEvents[i]->NpMsgrBuddy_OnMMCInvite( wstrFromId.c_str(), szPhoneTag.c_str(), wstrPassword.c_str(), wstrRoomTitle.c_str() ,wstrReqTalkName.c_str() );
			}
		} catch(CGBStreamException e)
		{
#if defined(WIN32)			
//			IK_TRACE("\t[%30s] CToC_MMCIVNITE exception\n",  e.ErrorMsg() );
#endif			
		}
		break;

	case CToC_MMC_FORCE_KICK:
		/*
			U2 : Sub Cmmand...
			U2 : Timeout...
			U8S : Msg1..
			U8S : Msg2.. */
		try
		{
			CGBStream stream;
			WSTRING msg1, msg2;
			WORD wTimeout;

			stream.UseExternalBuffer(pPacket->BodyData(), pPacket->BodyLength());
			stream.Skip(2);
			wTimeout = stream.Read_U2();
			stream.Read_U8S_to_Unicode_stl(msg1);
			stream.Read_U8S_to_Unicode_stl(msg2);

			int nEventsSize = static_cast<int>(m_vecEvents.size());
			for( int i=0 ; i <  nEventsSize; i++ )
				m_vecEvents[i]->NpMsgrBuddy_OnMMCForceKick(wTimeout, msg1.c_str(), msg2.c_str());
		} catch(CGBStreamException e)
		{
		}
		break;

	default:
		break;
	}

	//}
}

#if defined(WIN32)
void CALLBACK CNpMsgrBuddy::IkWnd_OnMessage(CIkWnd * pIkWnd, UINT message, WPARAM wParam, LPARAM lParam )
{

}
#endif


////////////////////////////////////////////////////////////////////////////////
// class CBuddy
/*
char const * __stdcall CBuddy::Id_MBCS(void)
{
	stl_ik_wcs2mbs( m_wstrId.c_str(), m_strTmpRet );
	return m_strTmpRet.c_str();
}
*/
unsigned char * __stdcall CBuddy::Id_UTF8(void)
{
#if defined(WIN32)
	int nUTF8_length = m_wstrId.length() * 6;

	if( m_nCurrentStringBufferLength <= nUTF8_length )
	{	
		if( m_pszCurrentStringBuffer )
			free( m_pszCurrentStringBuffer );

		m_nCurrentStringBufferLength = nUTF8_length + 1;
		m_pszCurrentStringBuffer = (char*)malloc(m_nCurrentStringBufferLength);
		if (NULL == m_pszCurrentStringBuffer)
			return NULL;
	}
	
	nUTF8_length = SimpleUTF16to8((const nfc::UTF16 *)m_wstrId.c_str(), m_wstrId.length(), (UTF8*)m_pszCurrentStringBuffer );
	m_pszCurrentStringBuffer[nUTF8_length] = 0;
	return (UTF8*)m_pszCurrentStringBuffer;
#else
	USES_UTF8_CONVERSION;
	
	const char *szTemp = W2U8(m_wstrId.c_str());
	
	if( m_pszCurrentStringBuffer )
		free( m_pszCurrentStringBuffer );

	m_nCurrentStringBufferLength = strlen(szTemp) + 1;
	m_pszCurrentStringBuffer = (char*)malloc(m_nCurrentStringBufferLength);
	memset(m_pszCurrentStringBuffer, 0, m_nCurrentStringBufferLength);
	
	strcpy(m_pszCurrentStringBuffer, szTemp);
	
#endif	
	return (unsigned char *)m_pszCurrentStringBuffer;
}

//LPCSTR __stdcall CBuddy::Nick_MBCS()
//{
//	stl_ik_wcs2mbs( m_wstrNick.c_str(), m_strTmpRet );
//	return m_strTmpRet.c_str();
//}

/*
LPCSTR __stdcall CBuddy::Name_MBCS()
{
	stl_ik_wcs2mbs( m_wstrName.c_str(), m_strTmpRet );
	return m_strTmpRet.c_str();
}

LPCSTR __stdcall CBuddy::MobilePhone_MBCS()
{
	stl_ik_wcs2mbs( m_wstrMobilePhone.c_str(), m_strTmpRet );
	return m_strTmpRet.c_str();
}
*/

LPCWSTR __stdcall CBuddy::GetProfile(LPCWSTR wszProfileName)
{
	int nSize = static_cast<int>(m_vecProfileData.size());
	for( int i=0 ; i <  nSize; i++ )
	{
		if( m_vecProfileData[i].m_wstrProfileName == wszProfileName )
		{
			return m_vecProfileData[i].m_wstrValue.c_str();
		}
	}

	return STR_EMPTY_WSTRING;
}

void __stdcall CBuddy::SetProfile(LPCWSTR wszProfileName, LPCWSTR wszValue)
{
	int nSize = static_cast<int>(m_vecProfileData.size());
	for( int i=0 ; i < nSize ; i++ )
	{
		if( m_vecProfileData[i].m_wstrProfileName == wszProfileName )
		{
			m_vecProfileData[i].m_wstrValue = wszValue;
			return;
		}
	}

	m_vecProfileData.push_back( CBuddyProfileData( wszProfileName, wszValue ) );

	return;
}


////////////////////////////////////////////////////////////////////////////////
// class CGroup

//LPCSTR __stdcall CGroup::GroupName_MBCS()
//{
//	stl_ik_wcs2mbs( m_wstrGroupName.c_str(), m_strTmpRet );
//	return m_strTmpRet.c_str();
//}



/*
#include "solar2lunar.h"

func()
{
	pBuddy->m_bIsBirthdayLunar = bIsBirthdayLunar;
	if( bIsBirthdayLunar &&
		strlen(szBirthDay) == 8 )
	{
		char tmp[32];
		
		Date dateLun;
		Date dateCurrent;

		// 2003.11.6 -> ȯ ¾ ظ ־༭ ¾    
		// ϴ  ϱ ؼ    ־. ȫ

		SYSTEMTIME lpTime;
		::GetLocalTime(&lpTime);
		
		dateCurrent.leap = 0;
		dateCurrent.weekday = 0;
	
		dateCurrent.year = lpTime.wYear;
			
		dateLun.leap = 0;
		dateLun.weekday = 0;
		 
		dateLun.year = lpTime.wYear;
		
		
		strncpy(tmp, szBirthDay+4, 2);
		tmp[2] = 0;
		dateLun.month = atoi( tmp );
		
		strncpy(tmp, szBirthDay+6, 2);
		tmp[2] = 0;
		dateLun.day = atoi( tmp );
	
#ifdef _DEBUG
		{
		
//			long y, m, d, isleap, lyuk, lgap;
//			Solar2Lunar( 1979, 2, 26, &y, &m, &d, &isleap, &lyuk, &lgap );

			Date dateSol;
			Date dateLun;

			dateSol.year = 1979;
			dateSol.month = 2;
			dateSol.day = 26;
			dateSol.leap = 0;
			dateSol.weekday = 0;

			Solar2Lunar( &dateSol, &dateLun );
			
			int a=0;

			Lunar2Solar( &dateLun, &dateSol );
			a=0;
		}
#endif
		Date dateSol;
		if( 0 == Lunar2Solar( &dateLun, &dateSol ) )
		{
			dateSol = dateLun;
		}
		// Lunar2Solar ؼ  ȯ   Ѿ 
		//   ִ ̴. ̰  ¥ 񱳸 ؼ ۳ 
		// ¥   ־־       . ȫ
		else if ( dateSol.year != dateLun.year )
		{
			dateLun.year -= 1;
			if ( 0 == Lunar2Solar( &dateLun, &dateSol ))
			{
				dateLun.year += 1;
				dateSol = dateLun;
			}
		}
		
		_snprintf(tmp, 10, "%04d%02d%02d", dateSol.year, dateSol.month, dateSol.day);

		pBuddy->m_strSolarDate_BirthDay = tmp;
	}
	else
		pBuddy->m_strSolarDate_BirthDay = pBuddy->m_strBirthDay;
}
*/

void __stdcall CNpMsgrBuddy::Force_SetBuddyStatus(LPCWSTR szBuddyId, E_MSGR_ONLINE_STATUS eStatus)
{

}
